#!/bin/sh
# the following restarts using tclsh \
exec tclsh "$0" "$@"

#
# load the library
#

# load .libs/libtclgpgme.so
package require gpgme


set ctx [gpgme::context]

set command [list $ctx -operation start-key]
if {[llength $argv] > 0} {
    lappend command -patterns [list [lindex $argv 0]]
}
eval $command
set s ""
while {[string compare [set key [$ctx -operation next-key]] ""]} {
    foreach {k v} [$ctx -operation info-key -key $key] {
        switch -- $k {
            subkeys {
                set i 0
                foreach subkey $v {
                    puts stdout "subkey #[incr i]"

                    foreach {k v} $subkey {
			if {[string compare $v ""]} {
                            puts stdout [format "    %12.12s: %s" $k $v]
			}
                    }
                }
            }

	    xml {
	    }

            default {
		if {[string compare $v ""]} {
                    puts stdout [format "    %12.12s: %s" $k $v]
		}
            }
        }
    }
}
$ctx -operation done-key

rename $ctx {}
